import { __assign, __awaiter, __generator } from "tslib";
import { ModulePrefix } from './../../index';
/**
 *
 * @param option {Function, Array<WordpressOption>, WordpressOption} - option
 * @describe It normalize option to array of options
 */
var resolveOption = function (option) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, response;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = typeof option;
                    switch (_a) {
                        case 'function': return [3 /*break*/, 1];
                        case 'object': return [3 /*break*/, 4];
                    }
                    return [3 /*break*/, 5];
                case 1: return [4 /*yield*/, option.call(this)];
                case 2:
                    response = _b.sent();
                    return [4 /*yield*/, resolveOption(response)];
                case 3: return [2 /*return*/, _b.sent()];
                case 4:
                    if (Array.isArray(option)) {
                        return [2 /*return*/, option];
                    }
                    else {
                        return [2 /*return*/, [option]];
                    }
                    _b.label = 5;
                case 5:
                    console.log("[VueWordpress] 'wordpress' option cannot be type of " + option);
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    });
};
/**
 *
 * @param option {WordpressOption} - Configuration for request
 * @returns {Promise} for request
 */
var prepareAction = function (option) {
    return this.$store.dispatch(ModulePrefix + "_post/load", option);
};
export default {
    beforeMount: function () {
        return __awaiter(this, void 0, void 0, function () {
            var options, err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.$options || !this.$options.wordpress) {
                            return [2 /*return*/];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, resolveOption.call(this, this.$options.wordpress)];
                    case 2:
                        options = _a.sent();
                        return [4 /*yield*/, Promise.all(options.map(function (option) { return __awaiter(_this, void 0, void 0, function () {
                                var slug, _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!(typeof option.slug === 'function')) return [3 /*break*/, 2];
                                            return [4 /*yield*/, option.slug.call(this)];
                                        case 1:
                                            _a = _b.sent();
                                            return [3 /*break*/, 3];
                                        case 2:
                                            _a = option.slug;
                                            _b.label = 3;
                                        case 3:
                                            slug = _a;
                                            return [2 /*return*/, prepareAction.call(this, __assign(__assign({}, option), { slug: slug }))];
                                    }
                                });
                            }); }))];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        console.log('[VueWordpress] Something went wrong inside beforeMount with', this.$options.wordpress);
                        console.log('[VueWordpress]', err_1);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    },
    serverPrefetch: function () {
        return __awaiter(this, void 0, void 0, function () {
            var options, err_2;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.$options || !this.$options.wordpress) {
                            return [2 /*return*/];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, resolveOption.call(this, this.$options.wordpress)];
                    case 2:
                        options = _a.sent();
                        return [4 /*yield*/, Promise.all(options.map(function (option) { return __awaiter(_this, void 0, void 0, function () {
                                var slug, _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!(typeof option.slug === 'function')) return [3 /*break*/, 2];
                                            return [4 /*yield*/, option.slug.call(this)];
                                        case 1:
                                            _a = _b.sent();
                                            return [3 /*break*/, 3];
                                        case 2:
                                            _a = option.slug;
                                            _b.label = 3;
                                        case 3:
                                            slug = _a;
                                            return [2 /*return*/, prepareAction.call(this, __assign(__assign({}, option), { slug: slug }))];
                                    }
                                });
                            }); }))];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        err_2 = _a.sent();
                        console.log('[VueWordpress] Something went wrong inside serverPrefetch with', this.$options.wordpress);
                        console.log('[VueWordpress]', err_2);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=index.js.map