import { Store } from 'vuex';
export declare enum ContentTypes {
    Page = 0,
    Post = 1,
    Menu = 2,
    Meta = 3
}
export declare enum FetchHookTypes {
    Created = 0,
    AsyncData = 1,
    VoidAsyncData = 2
}
export interface LoaderRequestElement {
    slug: string;
    meta?: Boolean;
    dataName?: string;
    type?: string;
    embed?: boolean;
}
export declare function isLoaderRequestElement(object: any): object is LoaderRequestElement;
export interface LoaderRequestElementWithValue extends LoaderRequestElement {
    value: any;
}
export interface MetaConfig {
    titleTemplate?: string;
}
export interface PluginConfig {
    url: string;
    lang: string;
    store: Store<any> | Boolean;
    requestPrefix?: string;
    menus?: Boolean | string | Array<string>;
    titleTemplate?: string;
    debugger?: Boolean;
}
export interface EditablePluginConfig {
    url: string;
    lang: string;
    requestPrefix?: string;
    titleTemplate?: string;
    debugger?: Boolean;
}
export interface VuexModulePost {
    types: {
        [key: string]: any;
    };
}
export interface WordpressOption {
    slug: string | (() => string);
    type?: string;
    embed?: Boolean;
    fields?: Array<string> | string;
    beforeSave?: (fetchedData: any) => any;
    beforeRequest?: (url: string) => string;
    beforeSaveFailed?: () => any;
}
